import Reference from './Reference';
import type { ISchema } from './util/types';
export declare type ConditionBuilder<T extends ISchema<any, any>, U extends ISchema<any, any> = T> = (values: any[], schema: T, options: ResolveOptions) => U;
export declare type ConditionConfig<T extends ISchema<any>, TThen extends ISchema<any, any> = T, TOtherwise extends ISchema<any, any> = T> = {
    is: any | ((...values: any[]) => boolean);
    then?: (schema: T) => TThen;
    otherwise?: (schema: T) => TOtherwise;
};
export declare type ResolveOptions<TContext = any> = {
    value?: any;
    parent?: any;
    context?: TContext;
};
declare class Condition<TIn extends ISchema<any, any> = ISchema<any, any>, TOut extends ISchema<any, any> = TIn> {
    refs: readonly Reference[];
    fn: ConditionBuilder<TIn, TOut>;
    static fromOptions<TIn extends ISchema<any, any>, TThen extends ISchema<any, any>, TOtherwise extends ISchema<any, any>>(refs: Reference[], config: ConditionConfig<TIn, TThen, TOtherwise>): Condition<TIn, TThen | TOtherwise>;
    constructor(refs: readonly Reference[], builder: ConditionBuilder<TIn, TOut>);
    resolve(base: TIn, options: ResolveOptions): ISchema<any, any, any, any>;
}
export default Condition;
